#ifndef CREATURES_H
#define CREATURES_H

enum
{
	CREATURE_IDLE,
	CREATURE_WAITING,
	CREATURE_WALKING,
	CREATURE_TURNING,
	CREATURE_PUSHING,
};

class Object;
class Creature : public AniObject
{
public:
	int status;
	int color;

	Coord coord, target;
	Vector pos;
	Object *push_object;

	int ori, target_ori;
	float h;

	float wait, turn, walk;

	float destroy;
	bool is_destroyed;
	void Destroy();

	Creature(AniMesh *mesh);
	void SetCoord(Coord c);
	void SetOrientation(int o);

	bool IsFree(Coord c);

	virtual void Update(float ticks);
	void Render();
};

class Monster : public Creature
{
public:
	Monster(AniMesh *mesh);

	void NewTask();
	virtual void Update(float ticks);
};

class Player : public Creature
{
public:
	Player(AniMesh *mesh);

//	void NewTask();
	void Update(float ticks);
};

class Object
{
public:
	int type;

	Coord coord, target;
	bool pushed;
	Vector pos;

	int ori;
	float h;

	float destroy;
	bool is_destroyed;


	Object(int type);
	void SetCoord(Coord c);
	void SetOrientation(int o);

	void Destroy();

	void Update(float ticks);
	void Render();
};


typedef std::list<Creature *> Monsters;
typedef std::list<Object *> Objects;
extern Monsters gMonsters;
extern Objects gObjects;
extern Player *gPlayer;

Object *object_at_coord(Coord c);
Creature *creature_at_coord(Coord c);
Object *object_at_coord_light(Coord c);
Creature *creature_at_coord_light(Coord c);

#endif
