#ifndef GAME_H
#define GAME_H

bool game_init();
bool game_loop();

void handle_keydown(int key, int mod);

class Camera
{
public:
	Vector pos, speed;
	float angle, angle_speed;
	float pitch, pitch_speed;
	float zoom, zoom_speed;

	Camera();

	void Update(float ticks);
	void Transform();
	Vector GetPos();
	Vector GetMouseVector();

};
///// GLOBAL SETTINGS /////

extern int gWidth;
extern int gHeight;
extern float gNear;
extern float gFar;
extern float gFov;

#define MAX_TEXTURES 32
#define MAX_MESHES 64

extern Mesh gMeshes[];
extern Font gFont;
extern Uint8 *gKeys;

enum {
	GMODE_NORMAL,
	GMODE_EDITOR
};


extern int gGameMode;
extern int gEditorTile;

extern Map *gCurMap;


extern int gMouseX;
extern int gMouseY;
extern float gMouseXNorm;
extern float gMouseYNorm;
extern int gMouseButtons;

enum
{
	TILE_NONE=-1,
	TILE_FLOOR,
	TILE_WALL,
	TILE_HOLE,
	TILE_PLAYER_START,
	TILE_MIRROR_A,
	TILE_MIRROR_B,
	TILE_CRATE,
	TILE_PRISM_A,
	TILE_PRISM_B,
	TILE_PRISM_C,
	TILE_PRISM_D,
	TILE_LIGHTSOURCE_A,
	TILE_LIGHTSOURCE_B,
	TILE_LIGHTSOURCE_C,
	TILE_LIGHTSOURCE_D,
	TILE_FILTER_R,
	TILE_FILTER_G,
	TILE_FILTER_B,
	TILE_BLOCK_W,
	TILE_BLOCK_R,
	TILE_BLOCK_G,
	TILE_BLOCK_B,
	TILE_EXIT,
	TILE_MONSTER_START_R,
	TILE_MONSTER_START_G,
	TILE_MONSTER_START_B,
	TILE_,
};

struct TileInfo
{
	const char *name;
	bool can_walk;
	bool is_object;
	bool light_ok;
};

extern TileInfo gTileInfo[];



#endif