#ifndef LIGHT_H
#define LIGHT_H

#define MAX_RAYS 512

class LightRay
{
public:

	Coord start, end;
	Vector endpos; //, startpos;
	int ori;
	int color;

	void Render();
};

typedef std::vector<LightRay> LightRays;

class LightTracer
{
public:

	LightRay rays[MAX_RAYS];

	int sources, total;
	
	LightTracer();

	void Update();
	void Render();

	void Clear();
	void AddSource(Coord c, int ori);

	void ComputeRay(LightRay &ray);
	bool IsFree(Coord c);
};

#endif
