#include "common.h"

int main(int argc, char **argv)
{
	srand(GetTickCount());

	// SDL

	if(SDL_Init(SDL_INIT_VIDEO)!=0)
	{
		printf("Can't init SDL\n");
		SDL_Quit();
		exit(5);
	}

//#ifdef _DEBUG
	if(!SDL_SetVideoMode(gWidth, gHeight, 0, SDL_OPENGL))
//#else
//	if(!SDL_SetVideoMode(gWidth, gHeight, 0, SDL_OPENGL | SDL_FULLSCREEN))
//#endif
	{
		printf("Can't open video mode\n");
		SDL_Quit();
		exit(5);
	}

	SDL_WM_SetCaption("Lightstream! by Codexus", NULL);
//	SDL_ShowCursor(0);

	// devIL

	ilInit();
	ilutRenderer(ILUT_OPENGL);

	if(!game_init())
	{
		printf("Can't initialize game\n");
		SDL_Quit();
		exit(5);
	}

	SDL_Event evt;
	bool done = false;

	while(!done)
	{
		while(SDL_PollEvent(&evt))
		{
			switch(evt.type)
			{
			case SDL_KEYDOWN:
				if(evt.key.keysym.sym == SDLK_ESCAPE)
					done = true;
				else
					handle_keydown(evt.key.keysym.sym, evt.key.keysym.mod);
				break;

			case SDL_QUIT:
				done = true;
				break;
			}
		}

		done =  done || game_loop();
	}

	SDL_Quit();
	return 0;
}

